//  DS1302 Trickle-Charge Timekeeping Chip
// Chin-Shiuh Shieh on 2014-12-02

#define DS1302_CE    2
#define DS1302_SCLK 21
#define DS1302_IO   20

void DS1302_write(unsigned char cmd,unsigned char data){
  unsigned char i;
  pinMode(DS1302_CE,OUTPUT);pinMode(DS1302_SCLK,OUTPUT);pinMode(DS1302_IO,OUTPUT);
  digitalWrite(DS1302_CE,HIGH);
  for(i=0;i<8;i++){
    if(cmd%2==1)digitalWrite(DS1302_IO,HIGH);else digitalWrite(DS1302_IO,LOW);cmd>>=1;
    digitalWrite(DS1302_SCLK,HIGH);digitalWrite(DS1302_SCLK,LOW);
  }
  for(i=0;i<8;i++){
    if(data%2==1)digitalWrite(DS1302_IO,HIGH);else digitalWrite(DS1302_IO,LOW);data>>=1;
    digitalWrite(DS1302_SCLK,HIGH);digitalWrite(DS1302_SCLK,LOW);
  }
  digitalWrite(DS1302_CE,LOW);
}

unsigned char DS1302_read(unsigned char cmd){
  unsigned char i,data=0;
  pinMode(DS1302_CE,OUTPUT);pinMode(DS1302_SCLK,OUTPUT);
  digitalWrite(DS1302_CE,HIGH);
  pinMode(DS1302_IO,OUTPUT);
  for(i=0;i<7;i++){
    if(cmd%2==1)digitalWrite(DS1302_IO,HIGH);else digitalWrite(DS1302_IO,LOW);cmd>>=1;
    digitalWrite(DS1302_SCLK,HIGH);digitalWrite(DS1302_SCLK,LOW);
  }
  if(cmd%2==1)digitalWrite(DS1302_IO,HIGH);else digitalWrite(DS1302_IO,LOW);cmd>>=1;
  digitalWrite(DS1302_SCLK,HIGH);
  pinMode(DS1302_IO,INPUT);digitalWrite(DS1302_IO,HIGH);
  for(i=0;i<7;i++){
    digitalWrite(DS1302_SCLK,LOW);
    data>>=1;if(digitalRead(DS1302_IO)==HIGH)data+=128;
    digitalWrite(DS1302_SCLK,HIGH);
  }
  digitalWrite(DS1302_SCLK,LOW);
  data>>=1;if(digitalRead(DS1302_IO)==HIGH)data+=128;
  digitalWrite(DS1302_CE,LOW);
  return(data);
}

void setup(void){
  Serial.begin(9600);
  pinMode(DS1302_CE,OUTPUT);digitalWrite(DS1302_CE,LOW);
  pinMode(DS1302_SCLK,OUTPUT);digitalWrite(DS1302_SCLK,LOW);
  pinMode(DS1302_IO,OUTPUT);digitalWrite(DS1302_IO,LOW);
}

void loop(void){
// DS1302_write(0x80,0x00); // Set Second
// DS1302_write(0x82,0x13); // Set Minute
// DS1302_write(0x84,0x16); // Set Hour
// DS1302_write(0x86,0x02); // Set Date
// DS1302_write(0x88,0x12); // Set Month 
// DS1302_write(0x8A,0x02); // Set Day
// DS1302_write(0x8C,0x14); // Set Year
  while(1){
    Serial.print("20");
    Serial.print(DS1302_read(0x8D),HEX); // Read Year
    Serial.print("-");
    Serial.print(DS1302_read(0x89),HEX); // Read Month
    Serial.print("-");
    Serial.print(DS1302_read(0x87),HEX); // Read Date
    Serial.print(", ");
    Serial.print(DS1302_read(0x85),HEX); // Read Hour
    Serial.print(":");
    Serial.print(DS1302_read(0x83),HEX); // Read Minute
    Serial.print(":");
    Serial.print(DS1302_read(0x81),HEX); // Read Second
    Serial.println();
    delay(1000);
  }
}
